<template>
    <div class="note-placeholder editor" :class="{'small': small}" @click="handleNoteSelection">
        <div class="note-header">
            <div class="title-section">
                <span class="title">{{note.title}}</span>
            </div>
            <div class="date-section">
                <span class="date">{{Intl.DateTimeFormat('en-GB').format(note.date)}}</span>
            </div>
        </div>
        <div class="body">
            <p>{{ _body }}</p>
        </div>
        <div class="footer">
            <span class="notebook-title">~ {{ note.notebook.name }}</span>
        </div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import _ from 'lodash'
import { INote } from '@/store/types/notebooks'

@Component
export default class App extends Vue {
    // Props

    @Prop() note!: INote
    @Prop({ default: false }) small!: boolean

    // Computed

    get _body() {
        if (!this.note || this.note.body.length < 1) return ''

        const body = this.note.body[0].insert

        if (!_.isString(body)) return ''

        const trimmedBody = body.substring(0, 110)

        if (trimmedBody.length <= 100) return trimmedBody

        return trimmedBody + '...'
    }

    // Methods

    handleNoteSelection() {
        this.$emit('selected', this.note)
    }
}
</script>